c$Id:$
      subroutine elmt01(d,ul,xl,ix,tl,s,p,ndf,ndm,nst,isw)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2014: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c     Modification log                                Date (dd/mm/year)
c       Original version                                    01/11/2006
c-----[--.----+----.----+----.-----------------------------------------]
c     Purpose:

c     Inputs:

c     Outputs:
c-----[--.----+----.----+----.-----------------------------------------]
      
      implicit none
      
      
      include 'eldata.h'
      include 'comblk.h'
      include 'hdata.h'
      include 'pointer.h'
      include 'cdata.h' !nen
      include 'tdata.h'
      include 'elplot.h'
      include 'elauto.h'
      include 'counts.h'
      include 'swvars.h'!duVnshSW -> if one displacement increments zero
      
      integer ix(*), ndf, ndm, nst, isw
      real*8 d(*),ul(ndf,nen,*),xl(ndm,nen),tl(*),s(nst,nst),p(nst)
      real*8 sqrt2
      real*8 FF(ndm,ndm),uu(nen,ndm)
      real*8 xx(nen,ndm),SW(3,4),XJAC,SHP(3,nen),BP1(ndm,nen)
      real*8 bp(ndm,nen),bpEps(3,nen*ndm)
      real*8 Balpha(2,4*nen)
      real*8 NChi(4,4*nen),FpChi(4),HpChiHat(4*nen),FpChiHat(4*nen)
      real*8 tau(ndm,ndm),cd(3,3),cChi(3,4),cx(4,3)
      real*8 alphaChi(2),g1(nen,nen),k1(ndm*nen,ndm*nen)
      real*8 kUU(ndm*nen,ndm*nen)
      real*8 kUChi(ndm*nen,4*nen),kChiU(4*nen,ndm*nen),
     1       kChiChi(4*nen,4*nen)
      real*8 fU(ndm*nen),fChi(4*nen)
      real*8 dXDFpChi(4,4),dMdalphaChi(2,2),MM(2),XX1(4)
      real*8 tauv(3),B4(ndm*nen,ndm*nen),invF(2,2)
      integer i,j, k, l, m, o, q,kk,ndfChi
      integer, parameter::nHistVars=30+4+2+3
      real*8 h1(nHistVars), hn(nHistVars)
      integer nnp, ngp
      logical:: FLG=.FALSE.  
      real*8, parameter:: Pi= 3.1415d0
      
     
    
     
      
      sqrt2=dsqrt(2.d0)
     

      
      if(isw.eq.1) then
        nh1=4*nHistVars                                        
!        
      endif
      
      if(isw.eq.14) then
        do j=1,4
          do i=0,2
            hr(nh1-1+(j-1)*nHistVars+14+i*4)=1.d0
          end do
        end do
!        
      endif
                                            
      
      if(isw.eq.3 .or. isw.eq.6) then
                                                    
       duVnshSW=1
        do I=1,nen; do j=1,2
          if(dabs(ul(j,I,2)).gt.1.d-10) duVnshSW=0
        end do; end do
        
        do j=1,ndm
          do i=1,nen
            uu(:,:)=transpose(ul(1:ndm,:,1))
          end do
        end do
        
        k=1
        do i=1,nen; do j=1,4
         HpChiHat(k)=ul(j+ndm,i,1)
         k=k+1
        end do; end do
        do i = 1,nen
         do j = 1,ndm
          xx(i,j) = xl(j,i)+uu(i,j)
         end do
        end do
       
     
       
      
       call int2d(2,ngp,SW)                                           
      
      
      
        kUU=0.d0;kUChi=0.d0;kChiU=0.d0;kChiChi=0.d0
        fU=0.d0;fChi=0.d0
        
        do nnp=1,ngp                                                   ! over integration points:
        
          call SHP2D( SW(1:2,nnp), xl, SHP, XJAC, ndm, nen, ix, FLG )  
          BP1=SHP(1:ndm,:)
          
          
          FF=transpose(matmul(BP1,xx))
          
          call invert(FF,2,2)
          invF=FF
          bp= transpose(matmul(transpose(BP1),invF))
          call invert(FF,2,2)
         
           bpEps=0.d0
           do j=1,nen
            bpEps(1,j*2-1) = bp(1,j)
            bpEps(2,j*2) = bp(2,j)
            bpEps(3,j*2-1) = bp(2,j)/sqrt2
            bpEps(3,j*2) = bp(1,j)/sqrt2
          end do
          
                   
          Balpha=0.d0
          k=1
          do j=1,nen
            Balpha(1,k)=-BP1(2,j)
            Balpha(1,k+1)=BP1(1,j)
            Balpha(2,k+2)=-BP1(2,j)
            Balpha(2,k+3)=BP1(1,j)
            k=k+4
          end do
          
        
          NChi=0.0d0
          k=1
          do j=1,nen
            NChi(1,k) = SHP(3,j)
            NChi(2,k+1) = SHP(3,j)
            NChi(3,k+2) = SHP(3,j)
            NChi(4,k+3) = SHP(3,j)
            k=k+4
          end do
!           
          FpChiHat=HpChiHat
          do i=1,nen
           FpChiHat(4*i-3)= FpChiHat(4*i-3)+1.d0
           FpChiHat(4*i)= FpChiHat(4*i)+1.d0
          end do
          
          FpChi = matmul(NChi,FpChiHat)
          alphaChi = matmul(Balpha,FpChiHat)
          do i=1,nHistVars; hn(i)=hr(nh1+(nnp-1)*nHistVars+i-1);end do
          do i=1,nHistVars; h1(i)=hr(nh2+(nnp-1)*nHistVars+i-1);end do
          

          call umatNL(hn,h1,FF,dt,FpChi,alphaChi,tau,cd,cChi,cx,  
     1 dXDFpChi,dMdalphaChi,ma)
     

          do i=1,nHistVars; hr(nh2+(nnp-1)*nHistVars+i-1)=h1(i);end do
          
          g1=0.d0
          do i =1,nen
            do j = 1,nen
              do k =1,ndm
                do q =1,ndm
                  g1(i,j)= g1(i,j)+bp(k,i)*tau(k,q)*bp(q,j)                 
                end do
              end do
            end do
         end do
        
         
         k1=0.d0
         do i=0,nen-1; do j=0,nen-1; do k=1,ndm
          k1(ndm*i+k, ndm*j+k)=g1(i+1,j+1)                                     
         end do; end do; end do
         
         
        
         B4 = matmul(matmul(transpose(bpEps),cd),bpEps)
         kUU=kUU + (k1+B4)*SW(3,nnp)*XJAC
         
         kUChi = kUChi+matmul(matmul(transpose(bpEps),cChi),NChi)*
     1          SW(3,nnp)*XJAC
         kChiU = kChiU-matmul(matmul(transpose(NChi),cx),bpEps)*
     1     SW(3,nnp)*XJAC         
         
         kChiChi = kChiChi+(matmul(matmul(transpose(Balpha),dMdalphaChi) 
     1   ,Balpha)-matmul(matmul(transpose(NChi),dXDFpChi),NChi))* 
     1   SW(3,nnp)*XJAC
         
         
         ! changing tau to a vector:
         tauv(1) = tau(1,1); tauv(2) = tau(2,2); tauv(3)=sqrt2*tau(1,2)
         !  .........................
         
         
         
         
         MM=h1(29:30); XX1=h1(25:28)
         
         
         fU = fU+matmul(transpose(bpEps),tauv)*SW(3,nnp)*XJAC
        
         fChi = fChi+(matmul(transpose(Balpha),MM)
     1   -matmul(transpose(NChi),XX1))*SW(3,nnp)*XJAC
         
         
         end do                                                        ! End for all integration points
      
        
        
        !Residual:                                                                               
!           
 
 
           ndfChi=ndf-ndm
           p = 0.d0                                                                                             
           do i=1,nen
            do j=1,ndm
             p(ndf*(i-1)+j) = -fU(ndm*(i-1)+j)
            end do
!            p(500)=0.d0
            do k=1,ndfChi
             p(ndf*(i-1)+ndm+k) = -fChi(ndfChi*(i-1)+k)
            end do
           end do
!         
        
        
!        !el stiffness:
!          
       
        do i=0,nen-1                                                                                    
         do j=0,nen-1
          do k=1,ndm; do l=1,ndm;
            s(ndf*i+k, ndf*j+l)=kUU(ndm*i+k,ndm*j+l)
          end do; end do
          do k=1,ndm; do l=1,ndfChi
            s(ndf*i+k, ndf*j+ndm+l)=kUChi(ndm*i+
     1       k,ndfChi*j+l)
          end do; end do
          do k=1,ndfChi; do l=1,ndm
            s(ndf*i+ndm+k, ndf*j+l)=kChiU(ndfChi*i+
     1       k,ndm*j+l)
          end do; end do
          do k=1,ndfChi; do l=1,ndfChi
            s(ndf*i+ndm+k, ndf*j+ndm+l)=kChiChi(ndfChi*i+
     1       k,ndfChi*j+l)
          end do; end do
         end do    
        end do
        
!         
      
      else
        
      endif  ! isw-if
      
       
      
      end subroutine
      
    
    
      
      subroutine umatNL(hn,h1,FF,dtime,FpChi,alphaChi,tau,cd,cChi,cx,
     1                  dXDFpChi,dMdalphaChi,ma)
      
        implicit none
!       include 'eldata.h'                                                              
      include 'comblk.h'
      include 'hdata.h'
      include 'pointer.h'
      include 'cdata.h' !nen
      include 'tdata.h'
      include 'elplot.h'
      include 'elauto.h'
      include 'counts.h'
      include 'swvars.h'!duVnshSW -> if one displacement increments zero
      
      
        real*8 FF(2,2), h1(*), hn(*), FF1(3,3)
        real*8 FpChi(4),alphaChi(2),tau(2,2),cd(3,3)
        real*8 cChi(3,4),cx(4,3),dXDFpChi(4,4)
     1                   ,dMdalphaChi(2,2)
        real*8 Pe(3,3),SS(3,3),CAlg(6,6),tauK(3,3),Fp22(2,2)
        real*8 Fpvec(4),XX1(4),Xs(4),ff2(4),absr,rs(4),dtime
        real*8 dFpDXS3(9,9),ax3(9,6),cdl3(6,6),dTauDXS3(6,9)
        real*8 II(4),IBoxFpT(4,4),fp1(4),term2(4)
        real*8 MM(2),E,ll2,drXDX(4,4),dXSDX(4,4)
        real*8 ax(4,3),dTauDXS(3,4),drXDFpChi(4,4)
        real*8 cdl(3,3),dFpDXS(4,4),term7(3,4),Xs3(3,3)
        real*8 term9(4,4),term10(3,4),term11(3,4),Fptvec(4), XsOld(4)
        real*8 drSDXS(4,4),HChi,dFpBoxTI(4,4),XBoxTI(4,4), dmyVec4(4)
        real*8 dFpDXSNum(4,4),tolR,dblDmy,S6in(6),dXMax,gammaAccIn
        integer i,j,k,n,ctr,kk,numTang,ctrMax,ma
        real*8 alpha2(2,2),alpha0,Norm_alpha,lnalpha
        real*8 bb,beta,G,nu,c0
        real*8, parameter:: Pi=3.1415d0
        
        
        integer diagnOn, logarithmic
        real*8 XSSn(2), dd(2,3), nn(2,3)
        diagnOn=0
        ctrMax=200
        
        dXMax=5.d0
        
        
        numTang=0
        tolR=1.d-7
        HChi = 1.d6
        E = 70.d3 
        bb= 0.286d-3
        beta=1.d0
        nu=0.34d0
        G= E/(2.d0*(1.d0+nu))
        
        alpha0=bb
        ll2=bb/alpha0
        c0=G*bb*beta/(2.d0*Pi*(1.d0-nu))
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
       if(diagnOn.eq.1) then 
        dd(1,1)=-0.5d0; dd(1,2)=dsqrt(3.d0)/2.d0; dd(1,3)=0.d0
        dd(2,1)=0.5d0; dd(2,2)=dsqrt(3.d0)/2.d0; dd(2,3)=0.d0
        nn(1,1)=-dsqrt(3.d0)/2.d0; nn(1,2)=-0.5d0; nn(1,3)=0.d0
        nn(2,1)=-dsqrt(3.d0)/2.d0; nn(2,2)=0.5d0; nn(2,3)=0.d0
       endif 
        
        
        
        
        

       if(nIter.lt.2) then
       S6in=hn(1:6); gammaAccIn=hn(13)
        Fp22(1,1) = hn(14); Fp22(1,2) = hn(15); Fp22(2,1) = hn(17)
        Fp22(2,2) = hn(18) 
        XX1=hn(25:28)
       else
        S6in=h1(1:6); gammaAccIn=h1(13)
        Fp22(1,1) = h1(14); Fp22(1,2) = h1(15); Fp22(2,1) = h1(17)
        Fp22(2,2) = h1(18) 
        XX1=h1(25:28)
       endif
      
       call invert(Fp22,2,2)
       
       k=1 
       do i=1,2
        do j=1,2
         Fpvec(k) = Fp22(i,j)
         k=k+1
        end do
       end do
       

         
       call matmulABT22Vgt(XX1,Fpvec,Xs)
       
       XsOld=Xs
       
       
       
       
       
       
       if(diagnOn.eq.1) then
        XSSn=0.d0; 
        do i=1,2; kk=1; do j=1,2; do k=1,2
          XSSn(i)=XSSn(i)+dd(i,j)*Xs(kk)*nn(i,k)
          kk=kk+1
        end do; end do; end do
        write(*,*) '***** *************************************'
        write(*,*) '     Xs_n=', Xs
        write(*,*) '***** *************************************'
       endif
       
       
       
       
       
       
       
       
       
!       changing 2D to 3D: and vector to matrix:

       FF1=0;FF1(1:2,1:2)=FF;FF1(3,3)=1.d0
       II = 0.d0;II(1)=1.d0;II(4)=1.d0
      !******************************************************************************8
      !******************************************************************************8
!        Newton loop:
       ctr=0
       do                                                               !Start Newton loop
        ctr=ctr+1
!      
        Xs3 =0.d0;k=1
        do i=1,2; do j=1,2
         Xs3(i,j) =Xs(k)
         k=k+1
        end do; end do
!      
      !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        if(numTang.eq.1) then
         k=1
         do i=1,2
          do j=1,2
           Xs3(i,j)=Xs3(i,j)+1.d-7
           call umatGNCryst(FF1,h1,hn,dtime,Pe,SS,tauK,CAlg,n,Xs3,
     1      dFpDXS3,ax3,cdl3,dTauDXS3,S6in,gammaAccIn,ma)
           Fp22(1,1) = h1(14); Fp22(1,2) = h1(15); Fp22(2,1) = h1(17)                                      
           Fp22(2,2) = h1(18) 
           call invert(Fp22,2,2)
           dFpDXSNum(1,k)=Fp22(1,1); dFpDXSNum(2,k)=Fp22(1,2)
           dFpDXSNum(3,k)=Fp22(2,1); dFpDXSNum(4,k)=Fp22(2,2)
           Xs3(i,j)=Xs3(i,j)-1.d-7
           k=k+1
          end do
         end do
        endif
      !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
       
       
        call umatGNCryst(FF1,h1,hn,dtime,Pe,SS,tauK,CAlg,n,Xs3,dFpDXS3,
     1                  ax3,cdl3,dTauDXS3,S6in,gammaAccIn,ma)
        S6in=h1(1:6); gammaAccIn=h1(13)
       
        Fp22(1,1) = h1(14); Fp22(1,2) = h1(15); Fp22(2,1) = h1(17)                                      
        Fp22(2,2) = h1(18) 
        call invert(Fp22,2,2)
       
       !for visualization:
        h1(31)=Fp22(1,1); h1(32)=Fp22(1,2)
        h1(33)=Fp22(2,1); h1(34)=Fp22(2,2)

        k=1
        do i=1,2
         do j=1,2
          Fpvec(k) = Fp22(i,j)
          k=k+1
         end do
        end do
       
        dmyVec4=Fpvec-FpChi
        call matmulABT22Vgt(dmyVec4,Fpvec,ff2)                                    
       
        do i=1,4; rs(i)=Xs(i)-HChi*ff2(i); end do
       
       
       
       
       
       
       
       
        if(numTang.eq.1) then
         do j=1,4
          dFpDXSNum(:,j)=(dFpDXSNum(:,j)-Fpvec)/1.d-7
         end do
        endif
       
!       
       
       
        call transformmat9tomat4(dFpDXS3,dFpDXS)
        if(numTang.eq.1) dFpDXS=dFpDXSNum
       
       
       
       
       
       
       
       
       
       
!      
       
       
       
        Fptvec = Fpvec
        Fptvec(2) = Fpvec(3);Fptvec(3) = Fpvec(2)
       
        call Box(II,Fptvec,IBoxFpT)
        fp1=Fpvec-FpChi
       
        call BoxT(fp1,II,dFpBoxTI)
       
        
        drSDXS = -HChi*(matmul((IBoxFpT+dFpBoxTI),dFpDXS))
       
        do i=1,4
          drSDXS(i,i)= drSDXS(i,i)+1.d0
        end do
        
       
       
       
       
       
       
       
       
       
       
        absr=0.d0
        do i=1,4; absr=absr+rs(i)**2; end do
        absr=dsqrt(absr) 
        
        
!        
        
        
        if(diagnOn.eq.1) then
         write(*,*) '******************************************'
         write(*,*) 'absr',absr,'ctr=',ctr
        endif
        if (absr.lt.tolR.or.ctr.gt.ctrMax) exit
      
        call invert(drSDXS,4,4)
       
       
       
        term2 = matmul(drSDXS,rs)
        XsOld=Xs
        
        Xs=Xs-matmul(drSDXS,rs)
       
       
       
       
       
       
       
        dblDmy=0.d0
        do i=1,4; dblDmy=dblDmy+(Xs(i)-XsOld(i))**2; end do
        dblDmy=dsqrt(dblDmy)
        if(dblDmy.gt.dXMax) Xs=XsOld-dXMax/dblDmy*term2
       
       
        if(diagnOn.eq.1) then
         dmyVec4=0.d0
         do i=1,2; kk=1; do j=1,2; do k=1,2
          dmyVec4(i)=dmyVec4(i)+dd(i,j)*Xs(kk)*nn(i,k)
          kk=kk+1
         end do; end do; end do

         write(*,*) '******************************************'
         write(*,*) '  ||dXs||=', dblDmy, 'dXSS=', 
     1                 dmyVec4(1)-XSSn(1), dmyVec4(2)-XSSn(2)
         write(*,*) '******************************************'
        endif
     
     
     
     
     
     
     
     
       end do ! End of Newton loop
      !******************************************************************************8
      !******************************************************************************8
      
      
      
!      changing 3D to 2D:

       
       tau=tauK(1:2,1:2)
!      
       
       
!      changing   dFpDXS3(9,9)..dFpDXS(4,4)     ax3(9,6)..ax(4,3)   cdl3(6,6)..cdl(3,3)   dTauDXS3(6,9)..dTauDXS(3,4)
       
     
       call transformmat96tomat43(ax3,ax)
       call transformmat6tomat3(cdl3,cdl)
       call transformmat69tomat34(dTauDXS3,dTauDXS)
       
!      
!      .........................
       if(diagnOn.eq.1) then
        write(*,*) ' '                                                                      
        write(*,*) ' '                                                                      
       endif
    
       
       
       
       
       
       
       h1(37:38)=alphaChi
       MM=0.d0;dMdalphaChi=0.d0                                                             
       
       Norm_alpha=0.d0
       do i=1,2; Norm_alpha=Norm_alpha+(alphaChi(i))**2; end do
       Norm_alpha=dsqrt(Norm_alpha)
       
       if(Norm_alpha.gt.alpha0) then
        logarithmic = 1
        lnalpha=log(Norm_alpha/alpha0)+1.d0
        do i=1,2
         do j=1,2
          alpha2(i,j)=alphaChi(i)*alphaChi(j)
         enddo
        enddo
         
        MM=c0*alphaChi*lnalpha/Norm_alpha
        do i=1,2
         dMdalphaChi(i,i)= lnalpha/Norm_alpha
        end do
        dMdalphaChi=dMdalphaChi-alpha2*(lnalpha-1.d0)/(Norm_alpha**3)
        dMdalphaChi=dMdalphaChi*c0
       else
        logarithmic = 0
        MM= c0*ll2*alphaChi/bb
        do i=1,2
         dMdalphaChi(i,i)= c0*ll2/bb
        end do
       endif
       h1(29:30) = MM
       h1(39) = logarithmic
       
       
       
       XX1= HChi*(Fpvec-FpChi)
       h1(25:28)=XX1
       
       
       
       call BoxT(XX1,II,XBoxTI)
       dXSDX=IBoxFpT+1.d0/HChi*XBoxTI
       
       drXDX = -HChi*matmul(dFpDXS,dXSDX)
       drXDFpChi = -matmul(dFpDXS,XBoxTI)
       
       do i=1,4
        drXDX(i,i)=  drXDX(i,i)+1.d0
        drXDFpChi(i,i) = drXDFpChi(i,i)+1.d0
       end do
       drXDFpChi = drXDFpChi*HChi
       
       call invert(drXDX,4,4)
       dXDFpChi =-matmul(drXDX,drXDFpChi)
!      
!        
       
       cx= HChi*matmul(drXDX,ax)
       

       
       cd=cdl+matmul(matmul(dTauDXS,dXSDX),cx)

       
!       
       cChi= matmul(dTauDXS,matmul(dXSDX,dXDFpChi))+
     1       matmul(dTauDXS,XBoxTI)
       

      end subroutine
      !----------------------------------------------------------------------------
       
      
      subroutine trnsfrmMat2Vec(AMat, AVec)
      
        implicit none
        real*8 AMat(3,*), AVec(6), sqrt2
        integer i,j,k
        sqrt2=dsqrt(2.d0)
        do i=1,2; do j=i+1,3; 
          if( dabs(AMat(i,j)-AMat(j,i)).gt.1.d-8 ) then
            write(*,*) 'AMat not sym'; stop
          endif
        end do; end do 
        
        
        do i=1,3; AVec(i)=AMat(i,i); end do
        AVec(4)=sqrt2*AMat(2,3); AVec(5)=sqrt2*AMat(1,3)
        AVec(6)=sqrt2*AMat(1,2)
      
      end subroutine
      
    !----------------------------------------------------------------------------
         
      subroutine transformmat9tomat4(AMat,res)
      
        implicit none
        real*8 AMat(9,9), res(4,4)
        integer i,j,k
        
        
        do i=1,2;do j=1,2; res(i,j) = AMat(i,j); end do; end do
        do i=1,2;do j=3,4; res(i,j) = AMat(i,j+1); end do; end do
        do i=3,4;do j=1,2; res(i,j) = AMat(i+1,j); end do; end do
        do i=3,4;do j=3,4; res(i,j) = AMat(i+1,j+1); end do; end do
        
      
      end subroutine
      !----------------------------------------------------------------------------
       
      subroutine transformmat96tomat43(AMat,res)
      
        implicit none
        real*8 AMat(9,6), res(4,3)
        integer i,j,k
        
        
        do i=1,2;do j=1,2; res(i,j) = AMat(i,j); end do; end do
        do i=1,2; res(i,3) = AMat(i,6); end do
        do i=3,4;do j=1,2; res(i,j) = AMat(i+1,j); end do; end do
        do i=3,4; res(i,3) = AMat(i+1,6); end do                                                    
      
      end subroutine
      !----------------------------------------------------------------------------
       
      subroutine transformmat69tomat34(AMat,res)
      
        implicit none
        real*8 AMat(6,9), res(3,4)
        integer i,j,k
        
        
        do i=1,2;do j=1,2; res(i,j) = AMat(i,j); end do; end do
        do i=1,2;do j=3,4; res(i,j) = AMat(i,j+1); end do; end do
        do j=1,2; res(3,j) = AMat(6,j); end do
        do j=3,4; res(3,j) = AMat(6,j+1); end do
        
      
      end subroutine
      !----------------------------------------------------------------------------
       
      subroutine trnsfrmVec2Mat(AMat, AVec)
      
        implicit none
        real*8 AMat(3,3), AVec(6), sqrt22
        integer i,j,k
        sqrt22=dsqrt(2.d0)/2.d0
        
        do i=1,3; AMat(i,i)=AVec(i); end do
        AMat(2,3)=sqrt22*AVec(4); AMat(1,3)=sqrt22*AVec(5)
        AMat(1,2)=sqrt22*AVec(6);
        AMat(3,2)=AMat(2,3); AMat(3,1)=AMat(1,3); AMat(2,1)=AMat(1,2)
      
      end subroutine
   !----------------------------------------------------------------------------
          
      subroutine Box(a,b,res)
      implicit none
      real*8 a(4), b(4),aa(2,2),bb(2,2),res(4,4)
      integer p(4),q(4)
      integer i,j,k
      
      
      k=1
      do i=1,2
        do j=1,2
          aa(i,j)=a(k)
          k=k+1
        end do
      end do
      
       k=1
      do i=1,2
        do j=1,2
          bb(i,j)=b(k)
          k=k+1
        end do
      end do
      
      p=(/1,1,2,2/)
      q=(/1,2,1,2/)
      
      do i=1,4
        do j=1,4
          res(i,j)=aa(p(i),p(j))*bb(q(j),q(i))
        end do
      end do
      
      
      
      end subroutine
      !----------------------------------------------------------------------------
       
       
      subroutine BoxT(a,b,res)
      implicit none
      real*8 a(4), b(4),aa(2,2),bb(2,2),res1(4,4)
      real*8 res(4,4)
      integer p(4),q(4)
      integer i,j,k
      
      
      k=1
      do i=1,2
        do j=1,2
          aa(i,j)=a(k)
          k=k+1
        end do
      end do
      k=1
      do i=1,2
        do j=1,2
          bb(i,j)=b(k)
          k=k+1
        end do
      end do
      
      p=(/1,1,2,2/)
      q=(/1,2,1,2/)
      
      do i=1,4
        do j=1,4
          res1(i,j)=aa(p(i),p(j))*bb(q(j),q(i))
        end do
      end do
      
      do i=1,4
        res(i,1)=res1(i,1)
        res(i,2)=res1(i,3)
        res(i,3)=res1(i,2)
        res(i,4)=res1(i,4)
      end do
      
      
      end subroutine
 !----------------------------------------------------------------------------
            
      subroutine Box3(A,B,res)
      implicit none
      real*8 A(3,3), B(3,3)
      real*8 res(9,9)
      integer p(9),q(9)
      integer i,j
      
      
         
      p=(/1,1,1,2,2,2,3,3,3/)
      q=(/1,2,3,1,2,3,1,2,3/)
      
      do i=1,9
        do j=1,9
          res(i,j)=A(p(i),p(j))*B(q(j),q(i))
        end do
      end do
      
      
      
      end subroutine
!----------------------------------------------------------------------------
        
      
      subroutine transformmat6tomat3 (amat6,amat3)
      
        implicit none
        real*8 amat6(6,6), amat3(3,3)
        integer i,j,k
        
        
        do i=1,2; do j=1,2
        amat3(i,j)=amat6(i,j)
        end do; end do
        do i=1,2
        amat3(3,i)=amat6(6,i)
        amat3(i,3)=amat6(i,6)
        end do
        amat3(3,3)= amat6(6,6)
        
      end subroutine
      
      !----------------------------------------------------------------------------
      
       subroutine matmulABT22Vgt(a,b,res)


        implicit none

        !     Declarations

        integer::i,j
        
        
        real*8,dimension(4)::a,b
        real*8, DIMENSION (4) :: res
        
        
        
        res(1) = a(1)*b(1)+a(2)*b(2)
        res(4) = a(3)*b(3)+a(4)*b(4)
        res(2) = a(1)*b(3)+a(2)*b(4)
        res(3) = a(3)*b(1)+a(4)*b(2)
        

       
                
      end subroutine
       !----------------------------------------------------------------------------
      
      subroutine getATBOXSA(aa, ATBOXSA)


        implicit none

        !     Declarations

        integer::i,j
        real*8, DIMENSION (3,3) :: aa
        integer, DIMENSION (6,2) :: q
        
        real*8,dimension(6)::p
        real*8, DIMENSION (6,6) :: ATBOXSA

        
        q=reshape((/1,2,3,2,1,1,1,2,3,3,3,2/),(/6,2/)) 
!        
        p=(/1.d0,1.d0,1.d0,sqrt(2.d0),sqrt(2.d0),sqrt(2.d0)/)
!        
        do i=1,6
          do j=1,6
            ATBOXSA(i,j) = 0.5d0*(p(i)*p(j)*(aa(q(j,1),q(i,1))*
     1        aa(q(j,2),q(i,2))+aa(q(j,2),q(i,1))*aa(q(j,1),q(i,2))))
          end do
        end do


!         write(*,*)'ATBOXSA is ', ATBOXSA

            
            
      end subroutine

      !----------------------------------------------------------------------------
       
      
      
      
      subroutine umatGNCryst(FF,h1,hn,dtime,PeC,SSC,tauK,CAlg1,n,Xs3,
     1                dFpDXS3,ax3,cdl3,dTauDXS3,S6in,gammaAccIn,ma)
                
      implicit none
      
!       include 'tdata.h'
!       include 'invert.f'
!       include 'hdata.h'
!       include 'pointer.h'
      include 'elauto.h'
      include 'counts.h'
      include 'swvars.h'
      integer, parameter::NSys=2 
      
      real*8 FF(3,3), h1(*), hn(*), S6in(6), gammaAccIn
      real*8 cc(3,3),E6(6),S6(6),Xi(3,3),gamAcc, fs(3,3)
      real*8 dGamAccDTauC, tau, dGammAccDS(6),g0ddt
      real*8 drSDTauC(6),hp(3,3),S4(6,6),sg,tolg,gg,gam0dot
      real*8 invfp(3,3), invFpN(3,3),AA(3,3),Ce(3,3),Se(3,3)
      real*8 tauR, BB(7,7), MS(NSys,6), mm
       
      real*8 absr,rr(7),dd(NSys,3),nn(NSys,3),dEDS(6,6)
      real*8 dTauR, tauC, tauCP, tauD, Dg,Dg2,dtime,pp,xx(7)
      real*8 rTau,tol,dGamAdm,C11,C12,C44,Dgs(NSys),
     1 Dg2s(NSys)
      real*8 dTauAdm, mFact,w2,dmyVec(3), S6tr(6),sgs(NSys)
      real*8 MSTld(6),dTld(3),nTld(3),CeD(3),SeN(3)
      real*8 CeMS(6), MSeS(6), barMS(NSys,6),dGam(2)
      real*8 Fe(3,3),invFp2(3,3), tauK(3,3), ATld(3,3)
      real*8 dFpDXS3(9,9),ax3(9,6),cdl3(6,6),dTauDXS3(6,9)
      
      
      
      
      
      real*8 invfpbox(6,6),dtldpr(3),n1(3),n2(3),n3(3)
     
      real*8 mtldprs(6),dgdx(7),B1(6,7),boxfp(6,6),Bsf(7,6)
      real*8 dxdc(7,6),dcse(6,6),fetr(3,3),fetrbox(6,6)
      real*8 C4(6,6),PeC(3,3),SSC(3,3),CAlg1(6,6)
      real*8 boxfpn(6,6),boxtfpn(6,6),CAlgg(6,6)
      real*8 FFT(3,3),R1(3,3),R2(3,3)
      real*8 dd1(3),dd2(3),nn1(3),nn2(3)
      real*8 MMa(NSys,9),MSTld2(NSys,6)
      real*8 term12(6,9),dxDXS(7,9)
      real*8 invAA(3,3),dgdx2(NSys,7)
      real*8 dFpDx(9,7),InvAABoxAA(9,9),dFpDc(9,6)
      real*8 fsBoxsfs(6,6),fsBoxsTfs(6,6),FpN(3,3)
      real*8 dSeTldDXS(6,9),Xs3(3,3),Xsa,mtldprs2(Nsys,6),Angle1,
     1        Angle2, Angle3, dir(21),iden(3,3),Ffinal6
      real*8 Pfinal6
      real*8, parameter:: Pi=3.1415d0
      ! ......................End
      
      integer i,j,k,l,alpha,tauLtTauR,regOn,ctr,outp,ctrTot,ovrstrs
     1        ,n,ma
      integer,parameter :: ctrTotMax=1000
      
      outp=0; ovrstrs=1
      
!  
      C11=107.744d3; C12=55.504d3; C44=26.12d3
      do i=1,6; do j=1,6; S4(i,j)=0.d0; end do; end do
      S4(1,1) = C11; S4(2,2) = C11; S4(3,3) = C11;
      S4(1,2) = C12; S4(1,3) = C12;
      S4(2,1) = C12; S4(2,3) = C12;
      S4(3,1) = C12; S4(3,2) = C12;
      S4(4,4) = 2.d0*C44; S4(5,5) = 2.d0*C44; S4(6,6) = 2.d0*C44
      
      w2=dsqrt(2.d0)
      tol=1.d-12; tolg=1.d-17
      
      gam0dot=1.d-3
      
      pp=10.d0
      
      
      
!      
!       if(nIter.gt.1) pp=10.d0
!       if(nIter.gt.1) pp=20.d0
      if(ovrstrs.eq.1) then; tauD=60.d0
      else; call getTauCAndTauCP(tauD,tauCP, hn(13),ovrstrs,ma); endif
!       dGamAdm=1.d1; dTauAdm=2.1d4!Youngs Modulus times .1 strain
      dGamAdm=5.d4; dTauAdm=2.1d1!Youngs Modulus
      if(hn(23).lt.1d-8.and.dtime.gt.1.d-12) then
        mm=dGamAdm/dTauAdm/dtime/gam0dot
!         mm=2.d0
!         write(*,*) 'exceptional setting of mm'
      else; mm=hn(23); endif
      mFact=1.3d0
      dTauR = tauD*(mm*tauD/pp)**(1.d0/(pp-1.d0))
      
      regOn=0
!       
      
      do i=1,6; S6(i)=S6in(i); end do
      k=14
      do i=1,3; do j=1,3; invFpN(i,j)=hn(k); k=k+1; end do; end do
      
      
      
      
      Angle1=60*Pi/180.d0;
     
      dir =(/201,341,281,351,201,175,79,121,133,175,316,288,169,281,
     1        119,351,201,288,316,341,201/)*Pi/180;
      
      
!      
     
     
      
      dd1(1)=cos(dir(ma));dd1(2)=sin(dir(ma));dd1(3)=0.d0
      dd2(1)=cos(dir(ma)+Angle1);dd2(2)=sin(dir(ma)+Angle1);dd2(3)=0.d0
      
      
       
       
      R2(1,1)=0.0d0;R2(1,2)=-1.d0;R2(1,3)=0.d0
      R2(2,1)=1.0d0;R2(2,2)=0.d0;R2(2,3)=0.d0
      R2(3,1)=0.0d0;R2(3,2)=0.d0;R2(3,3)=1.d0
      
      
      
      nn1= matmul(R2,dd1)
      nn2= matmul(R2,dd2)
      
    

      dd(1,1)= dd1(1);dd(1,2)= dd1(2);dd(1,3)= dd1(3)
      dd(2,1)= dd2(1);dd(2,2)= dd2(2);dd(2,3)= dd2(3)
      
      nn(1,1)= nn1(1);nn(1,2)= nn1(2);nn(1,3)= nn1(3)
      nn(2,1)= nn2(1);nn(2,2)= nn2(2);nn(2,3)= nn2(3)
      
      
       
!        
        
!       12 Slip Systems:
      if(NSys.eq.12) then 
        call getFCCDirectionsAndNormals(dd,nn)
      endif
      
      
      
      
      do i=1,3; do j=1,3
        fs(i,j)=0.d0
        do k=1,3; fs(i,j)=fs(i,j)+FF(i,k)*invFpN(k,j); end do
      end do; end do
      !cc= FF*FFT
      do i=1,3; do j=1,3
        cc(i,j)=0.d0
        do k=1,3; cc(i,j)=cc(i,j)+fs(k,i)*fs(k,j); end do
      end do; end do
      
      
      
      
      
      
!       
!      
      
      
      call invert(S4,6,6)
      call getTauCAndTauCP(tauC,tauCP, gammaAccIn,ovrstrs,ma)
      !           MS eintragen
      do alpha=1,NSys
        do i=1,3
          MS(alpha,i)=dd(alpha,i)*nn(alpha,i)
        end do
        MS(alpha,4)=(dd(alpha,2)*nn(alpha,3)+nn(alpha,2)*
     1dd(alpha,3))/w2
        MS(alpha,5)=(dd(alpha,1)*nn(alpha,3)+dd(alpha,3)*
     1nn(alpha,1))/w2
        MS(alpha,6)=(dd(alpha,1)*nn(alpha,2)+dd(alpha,2)*
     1nn(alpha,1))/w2
      end do
!       
!       Start Newton-loop:
      ctr=0; ctrTot=0
      do
        ctr=ctr+1; ctrTot=ctrTot+1
        if(ctr.gt.60) then; write(*,*) 'too many umat iter'; stop;endif
!        
      
      
      
      
      
        do i=1,6; E6(i)=0.d0; do j=1,6; E6(i)=E6(i)+S4(i,j)*S6(j)
        end do; end do
!         write(*,*) E6
        do i=1,3
          Ce(i,i)=2.d0*E6(i)+1.d0
          Se(i,i)=S6(i)
        end do
        Ce(2,3)=w2*E6(4); Ce(1,3)=w2*E6(5); Ce(1,2)=w2*E6(6)
        Se(2,3)=S6(4)/w2; Se(1,3)=S6(5)/w2; Se(1,2)=S6(6)/w2
        do i=2,3; do j=1,i-1; Ce(i,j)=Ce(j,i); Se(i,j)=Se(j,i);end do
        end do
!         
        do i=1,3; do j=1,3    
            hp(i,j) = 0.d0; Xi(i,j)= 0.d0
            do k=1,3; Xi(i,j)=Xi(i,j)+Ce(i,k)*Se(k,j); end do
        end do; end do
!         write(*,*) Se
!         write(*,*) Xi
        gamAcc=0.d0; dGamAccDTauC=0.d0
        
        tauLtTauR=1
        do alpha=1,NSys
          tau=0.d0
          do i=1,3; do j=1,3
            tau=tau+dd(alpha,i)*Xi(i,j)*nn(alpha,j)
          end do; end do
          
!           
!           
!           
          
          Xsa=0.d0                                                                                            
          do i=1,3; do j=1,3
            Xsa=Xsa+dd(alpha,i)*Xs3(i,j)*nn(alpha,j)
          end do; end do
          
          
          sg=sign(1.d0,tau-Xsa)
          sgs(alpha)=sg
          tauR = dTauR
          if(ovrstrs.eq.1) tauR = tauC+tauR
          if(dabs(tau-Xsa).gt.tauR) tauLtTauR=0
          call getGAndDg(tau-Xsa,tauC,tauR,tauD,pp,mm,sg,gg,Dg,Dg2,
     1     regOn,ovrstrs)
          
          
          
          
          
          dGam(alpha)=gam0dot*dtime*gg
          
          
          
          Dgs(alpha)=Dg; Dg2s(alpha)=Dg2
          if (dabs(gg)>tolg) then
            do i=1,3; do j=1,3
              hp(i,j)=hp(i,j)+gg*dd(alpha,i)*nn(alpha,j)
            end do; end do
            gamAcc=gamAcc+dabs(gg)
            dGamAccDTauC=dGamAccDTauC-Dg2
            
          end if
        end do!loop  over slip systems
        g0ddt=gam0dot*dtime
        gamAcc=hn(13) + g0ddt*gamAcc
        dGamAccDTauC=g0ddt*dGamAccDTauC
        
        do i=1,3; do j=1,3
          hp(i,j)=g0ddt*hp(i,j)
        end do; end do
        
        do i=1,6
          dGammAccDS(i)=0.d0; drSDTauC(i)=0.d0
          do j=1,6; dEDS(i,j)=0.d0; end do
        end do
        do alpha=1,NSys
          do i=1,3
            do j=1,3; AA(i,j)=-.5d0*hp(i,j); end do
            AA(i,i)=AA(i,i)+1.d0
          end do
          do i=1,3; do j=1,3; BB(i,j)=AA(i,j); end do; end do
          call invert(AA,3,3)
          do i=1,3;
            dmyVec(i)=0.d0; CeD(i)=0.d0; SeN(i)=0.d0
            do j=1,3
              dmyVec(i)=dmyVec(i)+AA(i,j)*dd(alpha,j)
              CeD(i)=CeD(i)+Ce(i,j)*dd(alpha,j)
              SeN(i)=SeN(i)+Se(i,j)*nn(alpha,j)
            end do
          end do
          do i=1,3
            do j=1,3; AA(i,j)=.5d0*hp(i,j); end do
            AA(i,i)=AA(i,i)+1.d0
          end do
          call invert(AA,3,3)
          do i=1,3; do j=1,3; ATld(i,j)=AA(i,j); end do; end do
          do i=1,3; do j=1,3; invfp(i,j)=0.d0
            do k=1,3; invfp(i,j)=invfp(i,j)+AA(i,k)*BB(k,j); end do
          end do; end do
          do i=1,3;
            dTld(i)=0.d0
            nTld(i)=0.d0
            do j=1,3
              dTld(i)=dTld(i)+Ce(i,j)*dmyVec(j)
              nTld(i)=nTld(i)+AA(j,i)*nn(alpha,j)
            end do
          end do
          do i=1,3
            MSTld(i)=dTld(i)*nTld(i)
            CeMS(i)=CeD(i)*nn(alpha,i)
            MSeS(i)=dd(alpha,i)*SeN(i)
          end do
          MSTld(4)=(dTld(2)*nTld(3)+dTld(3)*nTld(2))/w2
          CeMS(4)=(CeD(2)*nn(alpha,3)+nn(alpha,2)*CeD(3))/w2
          MSeS(4)=(SeN(2)*dd(alpha,3)+dd(alpha,2)*SeN(3))/w2
          MSTld(5)=(dTld(1)*nTld(3)+dTld(3)*nTld(1))/w2
          CeMS(5)=(CeD(1)*nn(alpha,3)+nn(alpha,1)*CeD(3))/w2
          MSeS(5)=(SeN(1)*dd(alpha,3)+dd(alpha,1)*SeN(3))/w2
          MSTld(6)=(dTld(2)*nTld(1)+dTld(1)*nTld(2))/w2
          CeMS(6)=(CeD(2)*nn(alpha,1)+nn(alpha,2)*CeD(1))/w2
          MSeS(6)=(SeN(2)*dd(alpha,1)+dd(alpha,2)*SeN(1))/w2
     
          do i=1,6
           MSTld2(alpha,i)=MSTld(i)                                                           
          end do
          
          
          do i=1,6; barMS(alpha,i)=CeMS(i); do j=1,6
            barMS(alpha,i)=barMS(alpha,i)+2.d0*S4(i,j)*MSeS(j)
          end do; end do
!           
          do i=1,6; do j=1,6
            dEDS(i,j)=dEDS(i,j)-Dgs(alpha)*MSTld(i)*barMS(alpha,j)
          end do; end do
          do i=1,6
            dGammAccDS(i) = dGammAccDS(i) + sgs(alpha)*Dgs(alpha)*
     1               barMS(alpha,i)
            drSDTauC(i) = drSDTauC(i) + sgs(alpha)*Dg2s(alpha)*
     1               MSTld(i)
          end do
        end do
        
        
        
        
        do i=1,6; drSDTauC(i)=g0ddt*drSDTauC(i); end do
        do i=1,6; dGammAccDS(i)=g0ddt*dGammAccDS(i); end do
          
        do i=1,6; do j=1,6; dEDS(i,j)=g0ddt*dEDS(i,j); end do; end do
!         
        do i=1,3; do j=1,3; 
          AA(i,j)=0.d0
          do k=1,3; AA(i,j)=AA(i,j)+invfp(k,i)*cc(k,j); end do
        end do; end do
        do i=1,3; do j=1,3
          Ce(i,j)=0.d0
          do k=1,3; Ce(i,j)=Ce(i,j)+AA(i,k)*invfp(k,j); end do
        end do; end do
        
        do i=1,3
          E6(i)=0.5d0*(Ce(i,i)-1.d0)
        end do
        E6(4)=Ce(2,3)/w2;E6(5)=Ce(1,3)/w2;E6(6)=Ce(1,2)/w2

        
        
        
        
!         
!       
        
        
        
         
        
        call getTauCAndTauCP(rTau, tauCP, gamAcc,ovrstrs,ma)
  !         
        BB = 0.d0
        do i=1,6
          BB(7,i)= tauCP*dGammAccDS(i); BB(i,7)=drSDTauC(i)
          do j=1,6; BB(i,j)=-S4(i,j)+dEDS(i,j); end do
        end do
        BB(7,7)= tauCP*dGamAccDTauC-1.d0
  !       
        do i=1,6
          rr(i)=E6(i)
          do j= 1,6; rr(i)=rr(i)-S4(i,j)*S6(j); end do
        end do
        rr(7)=rTau-tauC
  !      
        absr=0.d0
        do i=1,7; absr=absr+rr(i)**2; end do
        absr=dsqrt(absr)
        
!        
        
        if(outp.gt.0) write(*,*) 'absr=', absr
!         write(*,*) 'absr=', absr
!         read(*,*)
        if(absr/=absr) then
          write(*,*) 'absr/=absr, kkSW=', kkSW
          rmeas=max(rmeas,1.2d0)
          return
!           
        endif
        call invert(BB,7,7)
        if(absr>tol.and.ctrTot.lt.ctrTotMax) then
!           
          do i=1,7; 
            xx(i)=0.d0
            do j=1,7; xx(i)=xx(i)-BB(i,j)*rr(j); end do
          end do
          do i=1,6; S6(i)=S6(i)+xx(i); end do
          tauC=tauC+xx(7)
          
          
          
          
          if(ctr.gt.10) then
            mm=mm/3.d0
            ctr=0
            do i=1,6; S6(i)=hn(i); end do
            call getTauCAndTauCP(tauC,tauCP, hn(13),ovrstrs,ma)
            if(ovrstrs.eq.0) tauD=tauC
            dTauR = tauD*(mm*tauD/pp)**(1.d0/(pp-1.d0))

            if(outp.gt.0) write(*,*) 'decreasing mm=', mm
!             write(*,*) 'decreasing pp=', pp
          endif
          
          
          
        else if(tauLtTauR.eq.0.and.ctrTot.lt.ctrTotMax) then
!         
          if(outp.gt.0) write(*,*) "at least one tau gt tauR"
        
          mm=mFact*mm
          if(outp.gt.0) write(*,*) 'increasing mm=',mm
!           
          if(ovrstrs.eq.0) tauD=tauC
          dTauR = tauD*(mm*tauD/pp)**(1.d0/(pp-1.d0))
          ctr=0
!        
        else
          if(ctrTot.eq.ctrTotMax) rmeas=max(rmeas,1.2d0)
!           
          if(outp.gt.0) write(*,*) 'CONVERGED, ctrTot=', ctrTot
          do i=1,6; h1(i)=S6(i); h1(i+6)=E6(i); end do
          h1(13)=gamAcc
          k=14
          do i=1,3; do j=1,3
            h1(k)=0.d0
            do l=1,3; h1(k)=h1(k)+invFpN(i,l)*invfp(l,j); end do
            
            invFp2(i,j)=h1(k)
            
            k=k+1
          end do; end do
          
          h1(23)=mm
          h1(24)=pp
          
          if(outp.gt.0) write(*,*) 'mm=',mm
          do i=1,3; do j=1,3
            Fe(i,j)=0.d0
            do k=1,3
              Fe(i,j)=Fe(i,j)+FF(i,k)*invFp2(k,j)
            end do
          end do; end do
          do i=1,3; do j=1,3
            tauK(i,j)=0.d0
            AA(i,j)=0.d0
            do k=1,3
              AA(i,j)=AA(i,j)+Fe(i,k)*Se(k,j)
            end do  
          end do; end do
          do i=1,3; do j=1,3; do k=1,3
              tauK(i,j)=tauK(i,j)+AA(i,k)*Fe(j,k)
          end do; end do; end do
          if(outp.gt.0) then
            write(*,*) 'tauK='
            do i=1,3; write(*,*) tauK(i,:); end do
          endif
!          
          B1=0.d0
          do alpha=1,NSys          
         
            do i=1,3
              dtldpr(i)=0.d0
              n1(i) = 0.d0
              do j=1,3
                dtldpr(i)= dtldpr(i)+ATld(i,j)*dd(alpha,j)
                n1(i)= n1(i)+ATld(j,i)*nn(alpha,j)
              end do
            end do
          
            n2 = matmul(Se,n1)
            n3 = matmul(invfp,n2)
            
            do i =1,3
            mtldprs(i) = dtldpr(i)*n3(i)
            end do
            
            mtldprs(4) = (dtldpr(2)*n3(3)+dtldpr(3)*n3(2))/w2
            mtldprs(5) = (dtldpr(1)*n3(3)+dtldpr(3)*n3(1))/w2
            mtldprs(6) = (dtldpr(1)*n3(2)+dtldpr(2)*n3(1))/w2
            
            do i=1,6
            dgdx(i) = g0ddt*Dgs(alpha)*barMS(alpha,i)
            mtldprs2(alpha,i) = mtldprs(i)                                          
            end do
            
            dgdx(7) = -sgs(alpha)*g0ddt*Dg2s(alpha)
            
            do i=1,7                                                                
              dgdx2(alpha,i)=dgdx(i)
            end do
            
            do i = 1,6 ; do j = 1,7
            B1(i,j) = B1(i,j)-mtldprs(i)*dgdx(j)
            end do; end do
          
          end do
          
          B1=2.d0*B1
          
          call getATBOXSA(transpose(invfp), boxfp)
          do i =1,6; do j= 1,6
           B1(i,j) = B1(i,j)+boxfp(i,j)
          end do; end do
          
          call getATBOXSA(invfp, boxfp)
          do i =1,6; do j= 1,6
           Bsf(i,j) = boxfp(i,j)
          end do; end do
          
          do i =1,6; Bsf(7,i) =0.d0; end do
          
          
          dxdc = -0.5d0*matmul(BB,Bsf)
!           
          dcse = matmul(B1,dxdc)
!           
!          
          
          
          
          

           call getATBOXSA(transpose(invFpN), boxfpn)
           
        
           call getATBOXSA(invFpN, boxtfpn)
         
!        
          CAlgg = matmul(boxfpn,dcse)
          CAlg1 = matmul(CAlgg,boxtfpn)
!           
          
          call invert(FF,3,3)
          
          
          PeC = matmul(tauK,transpose(FF))
          SSC = matmul(FF,PeC)
                 
          call invert(FF,3,3)
           !                                                                                        
!          
          
          
          Ffinal6 = FF(1,2)
          Pfinal6 = PeC(1,2)
          
          h1(35)=Ffinal6
          h1(36)=Pfinal6
!           
         
          
          
          do i=1,NSys
            l = 1
            do j=1,3
              do k=1,3
                MMa(i,l)=dd(i,j)*nn(i,k)
                l=l+1
              end do
            end do
          end do
        
          term12=0.d0
          do alpha=1,NSys
            do i=1,6
              do j=1,9
                term12(i,j)=term12(i,j)+Dgs(alpha)*MSTld2(alpha,i)
     1                  *MMa(alpha,j)
              end do 
            end do
          end do
          term12=g0ddt*term12
          

        
          dxDXS = 0.d0  
          dxDXS(1:6,:)=term12
!           
          do alpha = 1,NSys ; do i=1,9
            dxDXS(7,i) = dxDXS(7,i)-sgs(alpha)*Dgs(alpha)*MMa(alpha,i)                             
          end do;end do
          dxDXS(7,:)=dxDXS(7,:)*tauCP*g0ddt
          
          dxDXS=-matmul(BB,dxDXS)
          AA=-0.5*hp; do i=1,3; AA(i,i)=1.d0+AA(i,i); end do
          invAA=AA
          call invert(invAA,3,3)
          FpN=invFpN
          call invert(FpN,3,3)
          
          
         call Box3(invAA,matmul(invAA,FpN),InvAABoxAA)
          
          dFpDx = 0.d0
          dFpDXS3 = 0.d0
          do alpha=1,NSys
            do i=1,9
              do j=1,7
                dFpDx(i,j)=dFpDx(i,j)+MMa(alpha,i)*dgdx2(alpha,j)
                dFpDXS3(i,j)=dFpDXS3(i,j)+Dgs(alpha)*MMa(alpha,i)
     1            *MMa(alpha,j)                                        
              end do
               do j=8,9
                dFpDXS3(i,j)=dFpDXS3(i,j)+Dgs(alpha)*MMa(alpha,i)
     1             *MMa(alpha,j)
              end do
            end do
           end do
          
          dFpDx = matmul(InvAABoxAA,dFpDx)
          dFpDc = matmul(dFpDx,dxdc)
          dFpDXS3 = matmul(dFpDx,dxDXS)-
     1     g0ddt*matmul(InvAABoxAA,dFpDXS3)
          
          call getATBOXSA(fs,fsBoxsfs)
          
          ax3 = 2.d0*matmul(dFpDc,fsBoxsfs)
          
          dSeTldDXS = 0.d0
          do alpha=1,NSys
            do i=1,6                                                                                    
              do j=1,9
                dSeTldDXS(i,j) = dSeTldDXS(i,j)+mtldprs2(alpha,i)
     1                   *MMa(alpha,j)*Dgs(alpha)
              end do
          end do;end do
          dSeTldDXS = matmul(B1,dxDXS)+2.d0*g0ddt*dSeTldDXS
          
          call getATBOXSA(transpose(fs),fsBoxsTfs)
          
          dTauDXS3 = matmul(fsBoxsTfs,dSeTldDXS)
          cdl3 = matmul(fsBoxsTfs,dcse)
          cdl3 = 2.d0*matmul(cdl3,fsBoxsfs)
          
        
          return
        end if
      end do!Newton loop
      
!      
      end subroutine umatGNCryst
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
     
     
      subroutine getGAndDg(tau,tauC,tauR,tauD,pp,mm,sg,gg,Dg,
     1                         Dg2,regOn,ovrstrs)
      implicit none
      real*8 tau,tauC,tauR,tauD,pp,mm,sg,gg,Dg,Dg2,
     1 fbar,dTauR
      integer regOn, ovrstrs
      if(ovrstrs.eq.1) then
        if (dabs(tau)<=tauC) then
          gg=0.d0; Dg=0.d0!; return
        else if(dabs(tau)<=tauR) then
          fbar= (dabs(tau)-tauC)/tauD
          Dg=fbar**(pp-1.d0)
          gg=sg*Dg*fbar
          Dg=pp/tauD*Dg
        else
          dTauR=tauR-tauC
          gg = sg*( mm*(dabs(tau)-tauR) + (dTauR/tauD)**pp )
          Dg=mm
        end if
        Dg2=Dg
      else
        if(dabs(tau)<=tauR) then
          fbar= dabs(tau)/tauC
          Dg=fbar**(pp-1.d0)
          gg=sg*Dg*fbar
          Dg=pp/tauC*Dg
          Dg2=fbar*Dg
        else
          dTauR=tauR
          gg = sg*( mm*(dabs(tau)-tauR) + (dTauR/tauC)**pp )
          Dg=mm
          Dg2=mm*(mm*tauC/pp)**(1.d0/(pp-1.d0))
        endif
      endif
      end subroutine getGAndDg
      
      
      
      
      
      
      
      
      
      
      
      
      
     
      
      subroutine getTauCAndTauCP(tauC,tauCP, gamAcc,ovrstrs,ma)
      implicit none
      include 'swvars.h'!duVnshSW -> if one displacement increments zero
      include 'counts.h'
      real*8 tauC0, H0, gamAcc, tauCP, tauC, tauInf, dHInf
      integer ovrstrs,ma
      H0=541.41d0; 
      dHInf=1.d0
      if(nIter.gt.-2) dHInf=1.d0
!      
      if(ovrstrs.eq.1) then
        tauC0=0.84d0; !0.5d0
        tauInf=49.51d0
        
        tauCP=H0*(dcosh(h0*gamAcc/(tauInf-tauC0)))**(-2.d0)+dHInf
        tauC=tauC0+(tauInf-tauC0)*dtanh(h0*gamAcc/(tauInf-tauC0))
     1    +dHInf*gamAcc
      else
        tauC0=50.d0; 
        tauInf=0.d0
               
        tauCP=H0*(dcosh(h0*gamAcc/(tauInf-tauC0)))**(-2.d0)!+1.d0
        tauC=tauC0+(tauInf-tauC0)*dtanh(h0*gamAcc/(tauInf-tauC0))
        
        


      endif

      end subroutine getTauCAndTauCP
      
      
      
      
      
      
      
      
      
      subroutine getExp(AA,LL)
      implicit none      
      real*8 AA(3,*),BB(3,3),LL(3,*),nfak,CC(3,3)
      integer i,j,k,n,nmax
!      
      nmax = 8
      nfak=1.d0
!       LL füllen
      do i=1,3; do j=1,3
        if(i.eq.j) then
          LL(i,j)=AA(i,j)+1.d0
        else 
          LL(i,j)=AA(i,j)
        end if
        BB(i,j)=AA(i,j)
        CC(i,j)=0.d0
      end do; end do
      do n=2,nmax
        do i=1,3; do j=1,3;do k=1,3
          CC(i,j)=CC(i,j)+BB(i,k)*AA(k,j)
        end do; end do; end do
        nfak=nfak*dble(n)
        do i=1,3; do j=1,3
          LL(i,j)=LL(i,j)+CC(i,j)/nfak
          BB(i,j)=CC(i,j)
          CC(i,j)=0.d0
        end do; end do
      end do      
      return
      end subroutine getExp
      
      
      subroutine getFCCDirectionsAndNormals(d,n)
      implicit none

      real*8 d(12,*), n(12,*),invW2,invW3
      invW2=1.d0/dsqrt(2.d0)
      invW3=1.d0/dsqrt(3.d0)
      !left rotation (right would also be possible):
      d(1,1)=0.d0;d(1,2)=invW2;d(1,3)=-invW2
      n(1,1)=invW3;n(1,2)=invW3; n(1,3)=invW3
      d(2,1)=-invW2;d(2,2)=0.d0;d(2,3)=invW2
      n(2,1)=invW3;n(2,2)=invW3; n(2,3)=invW3
      d(3,1)=invW2;d(3,2)=-invW2;d(3,3)=0.d0
      n(3,1)=invW3;n(3,2)=invW3; n(3,3)=invW3
      !right rotation:
      d(4,1)=0.d0;d(4,2)=invW2;d(4,3)=-invW2
      n(4,1)=-invW3;n(4,2)=invW3; n(4,3)=invW3
      d(5,1)=invW2;d(5,2)=0.d0;d(5,3)=invW2
      n(5,1)=-invW3;n(5,2)=invW3; n(5,3)=invW3
      d(6,1)=-invW2;d(6,2)=-invW2;d(6,3)=0.d0
      n(6,1)=-invW3;n(6,2)=invW3; n(6,3)=invW3
      !left rotation:
      d(7,1)=0.d0;d(7,2)=invW2;d(7,3)=invW2
      n(7,1)=-invW3;n(7,2)=invW3; n(7,3)=-invW3
      d(8,1)=invW2;d(8,2)=0.d0;d(8,3)=-invW2
      n(8,1)=-invW3;n(8,2)=invW3; n(8,3)=-invW3
      d(9,1)=-invW2;d(9,2)=-invW2;d(9,3)=0.d0
      n(9,1)=-invW3;n(9,2)=invW3; n(9,3)=-invW3
      !right rotation:
      d(10,1)=0.d0;d(10,2)=invW2;d(10,3)=invW2
      n(10,1)=invW3;n(10,2)=invW3; n(10,3)=-invW3
      d(11,1)=invW2;d(11,2)=-invW2;d(11,3)=0.d0
      n(11,1)=invW3; n(11,2)=invW3; n(11,3)=-invW3
      d(12,1)=-invW2;d(12,2)=0.d0;d(12,3)=-invW2
      n(12,1)=invW3; n(12,2)=invW3; n(12,3)=-invW3
      
      
      end subroutine getFCCDirectionsAndNormals
      
      
     