c$Id:$
      subroutine elmt02(d,ul,xl,ix,tl,s,p,ndf,ndm,nst,isw)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2014: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c     Modification log                                Date (dd/mm/year)
c       Original version                                    01/11/2006
c-----[--.----+----.----+----.-----------------------------------------]
c     Purpose:

c     Inputs:

c     Outputs:
c-----[--.----+----.----+----.-----------------------------------------]
      
      implicit none
      
      
      include 'eldata.h'
      include 'comblk.h'
      include 'hdata.h'
      include 'pointer.h'
      include 'cdata.h' !nen
      include 'tdata.h'
      include 'elplot.h'
      include 'elauto.h'
      include 'counts.h'
      include 'swvars.h'!duVnshSW -> if one displacement increments zero
      
      integer ix(*), ndf, ndm, nst, isw
      real*8 d(*),ul(ndf,nen,*),xl(ndm,nen),tl(*),s(nst,nst),p(nst)
      real*8 HpChiHat(4*nen),a12(2),Le,BChi(2),Bgamn(2)
      real*8 mChitr(2),Hk,HChigam,Hh,dmChidBChi(2,2),II(2,2),Ntld(2)
      real*8 ANtld,ftr,Bgam(2),delgam,alpha,dBgamdBChi(2,2)
      real*8 NHat(2,4),NN(2),XChitr(2),mChi(2)
      integer i,j, k 
      integer, parameter::nHistVars=4
      real*8 h1(nHistVars), hn(nHistVars)
      integer nnp, plStp,A,n_quad,n_initial,ss
      real*8 Angle, mc,power,Nmod,const,lambda(906)                   
      real*8, parameter:: Pi=3.1415d0
      
      if(isw.eq.1) then
        nh1=2*nHistVars
      endif
      
      if(isw.eq.3 .or. isw.eq.6) then              
       duVnshSW=1
       do I=1,2; do j=1,2
        if(dabs(ul(j,I,2)).gt.1.d-10) duVnshSW=0
       end do; end do
      
        
       k=1
       do i=1,2; do j=1,4
        HpChiHat(k)=ul(j+ndm,i,1)
        k=k+1
       end do; end do
!      
       a12(1)=xl(1,2)-xl(1,1)
       a12(2)=xl(2,2)-xl(2,1)
       Le=dsqrt(a12(1)**2+a12(2)**2)
       
       a12=a12/Le
       NN(1)=-a12(2);NN(2)=a12(1)
       
       NHat=0.d0;
       NHat(1,1)=-NN(2);NHat(2,3)=-NN(2);NHat(1,2)=NN(1)
       NHat(2,4)=NN(1)
      
       Hk=0.d0;HChigam=1.d6;Hh=0.d0  
       
       !-----------------------------------------------
       !  GB strength:
       
       
!          
       n_quad= 14657        ! number of quadrilateral elements
       n_initial = n_quad+1
       open(unit=10,file='Lambda_Final.txt')   
       read(10,*) (lambda(i),i=1,906)    ! num of elements on Gbs (or lambda)
       close(10)
       ss = n-n_initial+1   ! ss is a counter of elements (n is the element number)
       
       mc=1.d6
       if(lambda(ss).ge.0.5d0) then
        mc = 10.d0*(2.d0-lambda(ss))/lambda(ss)
       end if
       
!       
       !-----------------------------------------------
       
       II=0.d0
       II(1,1)=1.d0;II(2,2)=1.d0
       
       p=0.d0
       s=0.d0
       
       do nnp=1,2
       
        do i=1,nHistVars; hn(i)=hr(nh1+(nnp-1)*nHistVars+i-1);end do
          
        BChi(1)=-HpChiHat(4*nnp-3)*NN(2)+HpChiHat(4*nnp-2)*NN(1)
        BChi(2)=-HpChiHat(4*nnp-1)*NN(2)+HpChiHat(4*nnp)*NN(1)
          
        Bgamn=hn(1:2)
        mChitr=HChigam*(BChi-Bgamn)
          
        XChitr=Hk*Bgamn
        Ntld=mChitr-XChitr
!        
        ANtld=dsqrt(Ntld(1)**2+Ntld(2)**2)
        ftr=ANtld-(mc+Hh*hn(3))
          
          
        plStp=0
        if(ftr.gt.0.d0) plStp=1
        if(duVnshSW.eq.1) plStp=int(hn(4))
          
        if (plStp.eq.0) then
!         
         mChi=mChitr; Bgam=Bgamn; alpha=hn(3)
         dmChidBChi=HChigam*II


         
        else
!         
         Ntld= Ntld/ANtld
         delgam=ftr/(HChigam+Hh+Hk)
         Bgam=Bgamn+delgam*Ntld
         alpha=hn(3)+delgam
         mChi=HChigam*(BChi-Bgam)
  !           
         do i=1,2
          do j=1,2
           dBgamdBChi(i,j)=Ntld(i)*Ntld(j)
          enddo
         enddo
  !           
         dBgamdBChi=dBgamdBChi*(delgam/ANtld-1.d0/(HChigam+Hh+Hk))
            
         dBgamdBChi=HChigam*(delgam/ANtld*II-dBgamdBChi)
            
         dmChidBChi=HChigam*(II-dBgamdBChi)
      
            
            
        end if
        h1(1:2)=Bgam(1:2);h1(3)=alpha;h1(4)=dble(plStp)
        do i=1,nHistVars; hr(nh2+(nnp-1)*nHistVars+i-1)=h1(i);end do
        
        i=(nnp-1)*ndf+ndm+1
        p(i:ndf*nnp)=-matmul(transpose(NHat),mChi)*Le/2.d0
              
  !     
        s(i:ndf*nnp,
     1  i:ndf*nnp)=
     1  matmul(transpose(NHat),matmul(dmChidBChi,NHat))*Le/2.d0
              
          
       
       enddo
       
       
      endif
       
     
      end subroutine 
    