clear all
clc
close all

%% lambda distribution:

teta = (0:.1:180)*pi/180;

for i =1:length(teta)
Lambda(i) =0;
Angle(1) =  teta(i);
Angle(2) =  teta(i)+60*pi/180;
Angle(3) =  abs(60*pi/180-teta(i));
Angle(4) =  teta(i);

    for m=1:4
    if(Angle(m)>=pi)
        Angle(m) = abs(2*pi-Angle(m));
    end
    
    
    if (Angle(m)<(45*pi/180) || (135*pi/180)<Angle(m))
     Lambda(i) = Lambda(i)+ cos((90/45)*Angle(m))*cos((90/45)*Angle(m));
    end
    end
end

figure;
plot(teta*180/pi,Lambda,'b','LineWidth',2)
xl = xlabel('$\theta\ [^\circ]$','Interpreter','latex');
yl = ylabel('$\lambda$[-]','Interpreter','latex');
set(xl,'FontSize',14); 
set(yl,'FontSize',14);


% one slip system:
teta = (0:.1:180)*pi/180;

for i =1:length(teta)
Lambda(i) =0;
Angle(1) =  teta(i);

    for m=1:1
    if(Angle(m)>=pi)
        Angle(m) = abs(2*pi-Angle(m));
    end
    
    
    if (Angle(m)<(45*pi/180) || (135*pi/180)<Angle(m))
     Lambda(i) = Lambda(i)+ cos((90/45)*Angle(m))*cos((90/45)*Angle(m));
    end
    end
end

figure;
plot(teta*180/pi,Lambda,'b','LineWidth',2)
xl = xlabel('$\theta\ [^\circ]$','Interpreter','latex');
yl = ylabel('$\lambda$[-]','Interpreter','latex');
set(xl,'FontSize',14); 
set(yl,'FontSize',14);

%% mc distribution:

lambda = 0.5:.005:2;
A=10;


for i=1:length(lambda)
    
    
        mc(i) = A*(2-lambda(i))/lambda(i);
    
end

figure;
plot(lambda,mc,'b','LineWidth',2)
xl = xlabel('$\lambda\  $[-]','Interpreter','latex');
yl = ylabel('$m^{\rm c}\  $[N/m]','Interpreter','latex');
set(xl,'FontSize',14); 
set(yl,'FontSize',14);

% one slip system:
lambda1 = 0:.005:1;
A=10;


for i=1:length(lambda1)
    
    
        mc1(i) = A*(1-lambda1(i))/lambda1(i);
    
end

% figure;
% plot(lambda1,mc1,'b','LineWidth',2)
% xl = xlabel('$\lambda\  $[-]','Interpreter','latex');
% yl = ylabel('$m^{\rm c}\  $[N/m]','Interpreter','latex');
% set(xl,'FontSize',18); 
% set(yl,'FontSize',18);
% axis([0 1 0 800])